#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 1;
long long n, k, br[maxn], used[maxn], p[maxn];
long long ans_cnt, ans_sum;

struct edge{
    int x, y, idx;
};

vector<edge> v[maxn];
vector<int> ch;

void read(){
    cin >> n >> k;
    for(int i = 2;i <= n;i++){
        int x, w;
        cin >> x >> w;
        p[i] = x;
        v[x].push_back({i, w, i - 1});
    }
}

void dfs(int ver){
    if(!v[ver].size()){
        ch.push_back(ver);
        return;
    }
    used[ver] = 1;
    for(edge nb : v[ver]){
        if(!used[nb.x]) dfs(nb.x);
    }
}
void rec(int cnt, long long sum, int mx){
    if(cnt > ans_cnt){
        ans_cnt = cnt;
        ans_sum = sum;
    }
    else if(cnt == ans_cnt && sum < ans_sum){
        ans_sum = sum;
    }
    for(int i = 1;i <= n;i++){
        int sz = v[i].size();
        for(int j = 0;j < sz;j++){
            int nb = v[i][j].x, ind = v[i][j].idx;
            if(nb > mx && !used[ind] && br[i] < k && br[nb] < k){
                used[ind] = 1; br[i]++, br[nb]++;
                rec(cnt + 1, sum + v[i][j].y, nb);
                used[ind] = 0; br[i]--, br[nb]--;
            }
        }
    }
}

void dfs_up(int ch){
    if(ch == 1) return;
    int st = p[ch], fin = ch;
    if(br[st] < k && br[fin] < k){
        br[st]++;
        br[fin]++;
        ans_cnt++;
    }
    dfs_up(p[ch]);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    if(n <= 15) rec(0, 0, 0);
    else{
        dfs(1);
        int sz = ch.size();
        for(int i = 0;i < sz;i++){
            int st = p[ch[i]], fin = ch[i];
            if(br[st] < k && br[fin] < k){
                ans_cnt++;
                br[st] = 1, br[fin] = 1;
            }
        }
        for(int i = 0;i < sz;i++){
            dfs_up(ch[i]);
        }
    }
    cout << ans_cnt << " " << ans_sum << endl;
    return 0;
}
