#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5 + 1;
long long n, k, br[maxn], used[maxn], p[maxn];
long long ans_cnt, ans_sum;

struct edge{
    int x, y, idx;
};

vector<edge> v[maxn];
vector<int> ch;

void read(){
    cin >> n >> k;
    for(int i = 2;i <= n;i++){
        int x, w;
        cin >> x >> w;
        p[i] = x;
        v[x].push_back({i, w, i - 1});
    }
}

void rec(int cnt, long long sum, int mx){
    if(cnt > ans_cnt){
        ans_cnt = cnt;
        ans_sum = sum;
    }
    else if(cnt == ans_cnt && sum < ans_sum){
        ans_sum = sum;
    }
    for(int i = 1;i <= n;i++){
        int sz = v[i].size();
        for(int j = 0;j < sz;j++){
            int nb = v[i][j].x, ind = v[i][j].idx;
            if(nb > mx && !used[ind] && br[i] < k && br[nb] < k){
                used[ind] = 1; br[i]++, br[nb]++;
                rec(cnt + 1, sum + v[i][j].y, nb);
                used[ind] = 0; br[i]--, br[nb]--;
            }
        }
    }
}

void bfs(){
    queue<int> q;
    q.push(1);
    while(!q.empty()){
        int t = q.front(); q.pop();
        int sz = v[t].size();
        for(int i = 0;i < sz;i++){
            int nb = v[t][i].x;
            if(br[t] < k && br[nb] < k){
                br[t]++, br[nb]++;
                ans_cnt++;
            }
            q.push(nb);
        }
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    if(n <= 15) rec(0, 0, 0);
    else{
        bfs();
    }
    cout << ans_cnt << " " << ans_sum << endl;
    return 0;
}
